com.io7m.r2.filters

## Class R2BlurParameters

- java.lang.Object
- - com.io7m.r2.filters.R2BlurParameters

- All Implemented Interfaces:
    R2BlurParametersType

      @Generated(value={"Immutables.generator","R2BlurParametersType"})
      public final class R2BlurParameters
      extends Object
      implements R2BlurParametersType

  The type of blur parameters.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2BlurParameters.Builder` Builds instances of type `R2BlurParameters`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `blurPasses()` The number of blur passes that will be used.
    `float` | `blurScale()` The amount by which the image will be scaled during the blur operation.
    `com.io7m.jcanephora.core.JCGLFramebufferBlitFilter` | `blurScaleFilter()`
    `float` | `blurSize()`
    `static R2BlurParameters.Builder` | `builder()` Creates a builder for `R2BlurParameters`.
    `static R2BlurParameters` | `copyOf(R2BlurParametersType instance)` Creates an immutable copy of a `R2BlurParametersType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2BlurParameters` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `blurSize`, `blurScale`, `blurPasses`, `blurScaleFilter`.
    `static R2BlurParameters` | `of(float blurSize, float blurScale, int blurPasses, com.io7m.jcanephora.core.JCGLFramebufferBlitFilter blurScaleFilter)` Construct a new immutable `R2BlurParameters` instance.
    `String` | `toString()` Prints the immutable value `R2BlurParameters` with attribute values.
    `R2BlurParameters` | `withBlurPasses(int value)` Copy the current immutable object by setting a value for the `blurPasses` attribute.
    `R2BlurParameters` | `withBlurScale(float value)` Copy the current immutable object by setting a value for the `blurScale` attribute.
    `R2BlurParameters` | `withBlurScaleFilter(com.io7m.jcanephora.core.JCGLFramebufferBlitFilter value)` Copy the current immutable object by setting a value for the `blurScaleFilter` attribute.
    `R2BlurParameters` | `withBlurSize(float value)` Copy the current immutable object by setting a value for the `blurSize` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### blurSize

          public float blurSize()

      Specified by:
        `blurSize` in interface `R2BlurParametersType`
      Returns:
        The current blur size in texels

    - #### blurScale

          public float blurScale()

      The amount by which the image will be scaled during the blur operation. By scaling an image down, blurring it, and then scaling it back up again, the blur effect is emphasized without requiring additional passes.
      Specified by:
        `blurScale` in interface `R2BlurParametersType`
      Returns:
        The scale value for intermediate images

    - #### blurPasses

          public int blurPasses()

      The number of blur passes that will be used. If a value of `0` is given here, the image will only be scaled and not actually blurred (and will not actually even be scaled, if a value of `1.0` is given for `blurScale()`).
      Specified by:
        `blurPasses` in interface `R2BlurParametersType`
      Returns:
        The number of blur passes that will be used

    - #### blurScaleFilter

          public com.io7m.jcanephora.core.JCGLFramebufferBlitFilter blurScaleFilter()

      Specified by:
        `blurScaleFilter` in interface `R2BlurParametersType`
      Returns:
        The filter that will be used when an image is scaled via framebuffer blitting

    - #### withBlurSize

          public final R2BlurParameters withBlurSize(float value)

      Copy the current immutable object by setting a value for the `blurSize` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurSize
      Returns:
        A modified copy of the `this` object

    - #### withBlurScale

          public final R2BlurParameters withBlurScale(float value)

      Copy the current immutable object by setting a value for the `blurScale` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurScale
      Returns:
        A modified copy of the `this` object

    - #### withBlurPasses

          public final R2BlurParameters withBlurPasses(int value)

      Copy the current immutable object by setting a value for the `blurPasses` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurPasses
      Returns:
        A modified copy of the `this` object

    - #### withBlurScaleFilter

          public final R2BlurParameters withBlurScaleFilter(com.io7m.jcanephora.core.JCGLFramebufferBlitFilter value)

      Copy the current immutable object by setting a value for the `blurScaleFilter` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for blurScaleFilter
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2BlurParameters` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `blurSize`, `blurScale`, `blurPasses`, `blurScaleFilter`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2BlurParameters` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2BlurParameters of(float blurSize,
                                            float blurScale,
                                            int blurPasses,
                                            com.io7m.jcanephora.core.JCGLFramebufferBlitFilter blurScaleFilter)

      Construct a new immutable `R2BlurParameters` instance.
      Parameters:
        `blurSize` - The value for the `blurSize` attribute
        `blurScale` - The value for the `blurScale` attribute
        `blurPasses` - The value for the `blurPasses` attribute
        `blurScaleFilter` - The value for the `blurScaleFilter` attribute
      Returns:
        An immutable R2BlurParameters instance

    - #### copyOf

          public static R2BlurParameters copyOf(R2BlurParametersType instance)

      Creates an immutable copy of a `R2BlurParametersType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2BlurParameters instance

    - #### builder

          public static R2BlurParameters.Builder builder()

      Creates a builder for `R2BlurParameters`.
      Returns:
        A new R2BlurParameters builder

Copyright © 2017 <code@io7m.com> http://io7m.com